Index: /trunk/gli/classes/dictionary.properties
===================================================================
--- /trunk/gli/classes/dictionary.properties	(revision 6390)
+++ /trunk/gli/classes/dictionary.properties	(revision 6391)
@@ -230,5 +230,5 @@
 CDM.IndexManager.Remove_Index_Tooltip:Remove the selected index from the list
 CDM.IndexManager.Section:section
-CDM.IndexManager.Set_Default:Set Default
+CDM.IndexManager.Set_Default:Set Default Index
 CDM.IndexManager.Set_Default_Tooltip:Make the selected index the default index
 CDM.IndexManager.Source:Build index on:
@@ -247,18 +247,20 @@
 CDM.LanguageManager.Set_Default:Set Default
 CDM.LanguageManager.Set_Default_Tooltip:Make the selected language the default
+CDM.MetadataSetManager.Add:Add Metadata Set
+CDM.MetadataSetManager.Add_Tooltip:Open the Metadata Set Editor to allow the creation of a new metadata set
+CDM.MetadataSetManager.Configure:Configure Metadata Set
+CDM.MetadataSetManager.Configure_Tooltip:Open the Metadata Set Editor to allow the editing of the current selected set. This action may also be performed by double-clicking on the desired metadata set.
 CDM.MetadataSetManager.Elements:Elements in selected Metadata Set
-CDM.MetadataSetManager.Instructions:In this read-only design view you can review the Metadata Sets in your collection, what Elements they contain, and how they will appear in the collection configuration file.
+CDM.MetadataSetManager.Instructions:In this design view you can add, configure and remove the Metadata Sets in your collection and what Elements they contain.
+CDM.MetadataSetManager.Remove:Remove Metadata Set
+CDM.MetadataSetManager.Remove_Tooltip:Opens the Metadata Set Editor to remove the currently selected metadata set.
 CDM.MetadataSetManager.Sets:Available Metadata Sets
-CDM.MetadataSetManager.Title:{39}{46}Metadata Set Review{47}{34}
+CDM.MetadataSetManager.Title:{39}{46}Metadata Sets{47}{34}
 CDM.Move.At_Bottom:Cannot move the {0} {1} lower as it is already at the bottom of the list.
 CDM.Move.At_Top:Cannot move the {0} {1} higher as it is already at the top of the list.
 CDM.Move.Cannot:Cannot move the plugin {0} any lower as RecPlug and ArcPlug must be at the bottom of the list.
 CDM.Move.Fixed:<html>RecPlug and ArcPlug are generally required to be last and so are fixed in place.<br>If you really must move them please hand edit the collect.cfg file.</html>
-CDM.Move.Move_Bottom:Move To Bottom
-CDM.Move.Move_Bottom_Tooltip:Move the selected item to the bottom of the list
 CDM.Move.Move_Down:Move Down
 CDM.Move.Move_Down_Tooltip:Move the selected item down the list
-CDM.Move.Move_Top:Move To Top
-CDM.Move.Move_Top_Tooltip:Move the selected item to the top of the list
 CDM.Move.Move_Up:Move Up
 CDM.Move.Move_Up_Tooltip:Move the selected item up the list
@@ -267,5 +269,5 @@
 CDM.PlugInManager.Add_Tooltip:Use the specified plugin with this collection
 CDM.PlugInManager.Assigned:Currently Assigned Plugins
-CDM.PlugInManager.Configure:Configure Selected Plugin
+CDM.PlugInManager.Configure:Configure Plugin
 CDM.PlugInManager.Configure_Tooltip:Change the options of the selected plugin
 CDM.PlugInManager.Controls:Editing Controls
@@ -306,4 +308,5 @@
 CDM.SubcollectionManager.Name:Subcollection filter name:
 CDM.SubcollectionManager.Name_Tooltip:The name of the new subcollection filter
+CDM.SubcollectionManager.Partitions_Disabled:This facility is currently disabled because you are operating in {0-Current Mode} mode. It can only be accessed in {1-Systems} and {2-Expert} modes. Use File->Preferences to alter the mode of operation.
 CDM.SubcollectionManager.Remove:Remove Filter
 CDM.SubcollectionManager.Remove_Tooltip:Remove the selected filter from the list
@@ -389,5 +392,5 @@
 #
 #***** CreatePane *****
-CreatePane.Build:Build
+CreatePane.Build:Build Options
 CreatePane.Build_Tooltip:Options for the indexing and classification stage of collection formation
 CreatePane.Build_Collection:Build Collection
@@ -397,5 +400,5 @@
 CreatePane.Cancel_Build_Tooltip:Stop the collection formation process
 CreatePane.Copy_Progress:Copy Progress
-CreatePane.Import:Import
+CreatePane.Import:Import Options
 CreatePane.Import_Tooltip:Options for the file conversion and metadata assignment stage of collection formation
 CreatePane.Import_Progress:Import Progress
@@ -586,4 +589,12 @@
 #***** GShell *****
 GShell.Build:buildcol.pl
+GShell.Build.Auxilary:Creating auxiliary files and tidying up...
+GShell.Build.BuildBegun1:**************** Build Begun ****************
+GShell.Build.BuildComplete1:************** Build Complete ***************
+GShell.Build.CompressText:Compressing text...
+GShell.Build.FatalError.NoRunMGPasses:Fatal Error. MGPasses cannot be executed.
+GShell.Build.Index:Creating an index based on {0-index source and level}...
+GShell.Build.InfoDatabase:Creating information database...
+GShell.Build.Phind:Generating a Phind classifier. This may take some time...
 GShell.Command:Command
 GShell.Export:exportcol.pl
@@ -591,4 +602,17 @@
 GShell.Failure:Command failed.
 GShell.Import:import.pl
+GShell.Import.Are:are
+GShell.Import.FileNotProcessed:The file at {0-target file path} is of a type not recognised by any Greenstone plugin and can't be added.
+GShell.Import.FileProcessing:The file at {0-target file path} is a type recognised by the plugin {1-plugin name} and will be added.
+GShell.Import.ImportBegun1:*************** Import Begun ****************
+GShell.Import.ImportComplete1:************** Import Complete **************
+GShell.Import.ImportComplete2:Of the {0-number documents considered} 'documents' found while building this collection:
+GShell.Import.ImportComplete.Processed:{0-number processed} {1-were or was} recognised by plugins and {2-are or is} available in the collection
+GShell.Import.ImportComplete.Blocked:{0-number blocked} {1-were or was} prevented from being added by plugins (such as images in web pages)
+GShell.Import.ImportComplete.Ignored:{0-number ignored} {1-were or was} not recognised by plugins and {2-are or is} not available in collection
+GShell.Import.ImportComplete3:\n
+GShell.Import.Is:is
+GShell.Import.Was:was
+GShell.Import.Were:were
 GShell.New:makecol.pl
 GShell.Other:other
@@ -819,5 +843,5 @@
 #
 #***** Missing EXEC *****
-MissingEXEC.Message:Warning! You will not be able to view your new collections within the Librarian Interface unless you specify the path to the locally running Greenstone Library Webserver. You can enter this now in the text field below, or later by going to Preferences and choosing the Connection tab. Remember the a valid url must start with the protocol "http://", and end with the execuable name ("library" for Greenstone local library server, "gsdl" for other web servers).
+MissingEXEC.Message:Warning! You will not be able to view your new collections within the Librarian Interface unless you specify the path to the locally running Greenstone Library Webserver. You can enter this now in the text field below, or later by going to Preferences and choosing the Connection tab. Remember the a valid url must start with the protocol "http://", and will probably end with the executable name ("library" for Greenstone local library server, "gsdl" for other web servers).
 MissingEXEC.Title:Missing Greenstone Library Address
 #***** Missing GSDL *****
@@ -978,5 +1002,5 @@
 Preferences.General.Interface_Language:Interface Language:
 Preferences.General.Interface_Language_Tooltip:Select the language you wish the interface and its controls to be displayed in. 
-Preferences.General.Recursion_Depth:Maximum folder recursion depth:
+Preferences.General.Recursion_Depth:Maximum recursion depth:
 Preferences.General.Recursion_Depth_Tooltip:The maximum depth of folders copied in a file action before a recursive path is suspected
 Preferences.General.Restart_Required:GLI should now be restarted in order to complete loading a new interface language.
@@ -987,5 +1011,5 @@
 Preferences.Mode:Mode
 Preferences.Mode_Tooltip:Click on an entry to select a suitable level of operation
-Preferences.Mode.Assistant:Librarian Assistant
+Preferences.Mode.Assistant:Library Assistant
 Preferences.Mode.Assistant_Description:Use this setting to gain access to the basic features of the Greenstone Librarian Interface: adding documents and metadata to collections, creating new collections whose structure mirrors existing ones, and building collections.
 Preferences.Mode.Librarian:Librarian
@@ -994,5 +1018,5 @@
 Preferences.Mode.Systems_Description: This setting enables full use of the Greenstone Librarian Interface. To take advantage of all the features available, you will need to be able to formulate regular expressions.
 Preferences.Mode.Expert:Expert
-Preferences.Mode.Expert_Description:This setting enables expert use of the Greenstone Librarian Interface. It is recommended for users who are experienced with Greenstone, are familiar with running PERL scripts and examining their output, and are comfortable using regular expression syntax. All features of the Greenstone Librarian Interface are enabled. 
+Preferences.Mode.Expert_Description:This setting enables expert use of the Greenstone Librarian Interface. It is recommended for users who are experienced with Greenstone, and are familiar with running PERL scripts and using their output for troubleshooting. All features of the Greenstone Librarian Interface are enabled. 
 Preferences.Warnings:Warnings
 Preferences.Warnings_Tooltip:Enable or disable various warning dialogs