Index: /trunk/gli/classes/dictionary.properties
===================================================================
--- /trunk/gli/classes/dictionary.properties	(revision 6472)
+++ /trunk/gli/classes/dictionary.properties	(revision 6473)
@@ -590,6 +590,7 @@
 GShell.Build:buildcol.pl
 GShell.Build.Auxilary:Creating auxiliary files and tidying up...
-GShell.Build.BuildBegun1:**************** Build Begun ****************
-GShell.Build.BuildComplete1:************** Build Complete ***************
+GShell.Build.BuildBegun1:************** Build  Started **************
+GShell.Build.BuildCancelled:**************   Cancelled    **************
+GShell.Build.BuildComplete1:************** Build Finished **************
 GShell.Build.CompressText:Compressing text...
 GShell.Build.FatalError.NoRunMGPasses:Fatal Error. MGPasses cannot be executed.
@@ -603,12 +604,12 @@
 GShell.Import:import.pl
 GShell.Import.Are:are
-GShell.Import.FileNotProcessed:The file at {0-target file path} is of a type not recognised by any Greenstone plugin and can't be added.
-GShell.Import.FileProcessing:The file at {0-target file path} is a type recognised by the plugin {1-plugin name} and will be added.
-GShell.Import.ImportBegun1:*************** Import Begun ****************
-GShell.Import.ImportComplete1:************** Import Complete **************
+GShell.Import.FileNotProcessed:The file at {0-target file path} cannot be added because its type is not recognised by any Greenstone plugin.
+GShell.Import.FileProcessing:The file at {0-target file path} bas been recognised by the {1-plugin name} plugin and is being added.
+GShell.Import.ImportBegun1:************** Import  Started **************
+GShell.Import.ImportComplete1:************** Import Finished **************
 GShell.Import.ImportComplete2:Of the {0-number documents considered} 'documents' found while building this collection:
 GShell.Import.ImportComplete.Processed:{0-number processed} {1-were or was} recognised by plugins and {2-are or is} available in the collection
 GShell.Import.ImportComplete.Blocked:{0-number blocked} {1-were or was} prevented from being added by plugins (such as images in web pages)
-GShell.Import.ImportComplete.Ignored:{0-number ignored} {1-were or was} not recognised by plugins and {2-are or is} not available in collection
+GShell.Import.ImportComplete.Ignored:{0-number ignored} {1-were or was} not recognised by plugins and {2-are or is} not available in the collection
 GShell.Import.ImportComplete3:\n
 GShell.Import.Is:is
@@ -1014,9 +1015,9 @@
 Preferences.Mode.Assistant_Description:Use this setting to gain access to the basic features of the Greenstone Librarian Interface: adding documents and metadata to collections, creating new collections whose structure mirrors existing ones, and building collections.
 Preferences.Mode.Librarian:Librarian
-Preferences.Mode.Librarian_Description:This setting gives normal use of the Greenstone Librarian Interface: adding documents and metadata to collections, designing new collections, and building collections.
+Preferences.Mode.Librarian_Description:This setting gives normal use of the Greenstone Librarian Interface: creating and designing new collections, adding documents and metadata to collections, designing new collections, and building collections.
 Preferences.Mode.Systems:Library Systems Specialist
 Preferences.Mode.Systems_Description: This setting enables full use of the Greenstone Librarian Interface. To take advantage of all the features available, you will need to be able to formulate regular expressions.
 Preferences.Mode.Expert:Expert
-Preferences.Mode.Expert_Description:This setting enables expert use of the Greenstone Librarian Interface. It is recommended for users who are experienced with Greenstone, and are familiar with running PERL scripts and using their output for troubleshooting. All features of the Greenstone Librarian Interface are enabled. 
+Preferences.Mode.Expert_Description:This setting enables expert use of the Greenstone Librarian Interface. It is recommended for users who are experienced with Greenstone, and are able to perform troubleshooting tasks that involve interpreting debugging output from PERL scripts. All features of the Greenstone Librarian Interface are enabled.
 Preferences.Warnings:Warnings
 Preferences.Warnings_Tooltip:Enable or disable various warning dialogs