Index: /trunk/gli/metadata/dublin.mds
===================================================================
--- /trunk/gli/metadata/dublin.mds	(revision 6587)
+++ /trunk/gli/metadata/dublin.mds	(revision 6588)
@@ -134,4 +134,25 @@
   </SetLanguage>
 
+  <!-- Czech Version from http://www.ics.muni.cz/dublin_core/DC-czech-1.1.html -->
+  <!-- Ustav vypocetni techniky Masarykovy univerzity v Brne -->
+  <SetLanguage code="cs">
+    <Name>Soubor metadatovÃœch prvkÅ¯ Dublin Core, verze 1.1: referenÄnÃ­ popis</Name>
+    <Description>Tento dokument je ÄeskÃœm pÅekladem anglickÃ© verze referenÄnÃ­ho popisu souboru metadatovÃœch prvkÅ¯  Dublin Core, verze 1.1 [DCEN1.1]. Tento dokument nahrazuje ÄeskÃœ pÅeklad souboru metadatovÃœch prvkÅ¯ Dublin Core, verze 1.0 [DCCS1.0]. DalÅ¡Ã­ informace o pracovnÃ­ch seminÃ¡ÅÃ­ch (workshopech), zprÃ¡vÃ¡ch, studiÃ­ch pracovnÃ­ch skupin, projektech a dalÅ¡Ã­m vÃœvoji souboru metadatovÃœch prvkÅ¯ Dublin Core najdete na domovskÃ© strÃ¡nce Dublin Core (http://purl.org/dc)</Description>
+  </SetLanguage>
+
+  <!-- Dutch Version from http://www.kb.nl/coop/donor/project-nl-index.html?/coop/donor/rapporten/DCsimpleformat.html -->
+  <!-- by ... -->
+  <SetLanguage code="nl">
+    <Name>Rapporten Dublin Core Simple Format</Name>
+    <Description>Dit document beschrijft welke Dublin Core metadata elementen er zijn en geeft een korte definitie van elk element. Voor uitgebreide uitleg en gebruik van de Dublin Core elementen wordt u verwezen naar de gebruikershandleiding. Deze vertaling geeft ook de keuzes aan voor standaarden (taalcodes, datum codes) die wij in DONOR verband gaan hanteren. In zoverre kan deze vertaling afwijken van het oorspronkelijke document "Description of Dublin Core Elements" http://purl.org/metadata/dublin_core_elements"</Description>
+  </SetLanguage>
+
+  <!-- Finnish Version from http://www.lib.helsinki.fi/dublin_core/dcref-fin.html -->
+  <!-- by Jani Stenvall and Juha Hakala, Helsinki University Library -->
+  <SetLanguage code="fi">
+    <Name></Name>
+    <Description></Description>
+  </SetLanguage>
+
   <!-- Interlingua Version sourced from http://www.nautilus.com.br/%7Eensjo/ia/purl.org/dc/documents/rec-dces-19990702.htm -->
   <!-- by Emerson Jose` Silveira da Costa -->
@@ -200,4 +221,24 @@
 ¬åŒçåç§°ã</Attribute>
     </Language>
+
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">NÃ¡zev</Attribute>
+      <Attribute name="definition">JmÃ©no danÃ© zdroji.</Attribute>
+      <Attribute name="comment">NÃ¡zev bude typicky jmÃ©no, pod nÃ­mÅŸ je zdroj oficiÃ¡lnÄ znÃ¡m.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Titel</Attribute>
+      <Attribute name="definition">De naam van de Internetbron. Meestal gegeven door de auteur, maker of uitgever</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
+    </Language> 
 
     <!-- Interlingua -->
@@ -285,4 +326,24 @@
 æ¬äžªäººïŒç»ç»ææé¡¹æå¡ãäžè¬èèšïŒçšåå»ºè
 çåç§°æ¥æ è¯è¿äžæ¡ç®ã</Attribute>
+    </Language>
+
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">TvÅ¯rce</Attribute>
+      <Attribute name="definition">Entita primÃ¡rnÄ odpovÄdnÃ¡ za vytvoÅenÃ­ obsahu zdroje.</Attribute>
+      <Attribute name="comment">PÅÃ­klady TvÅ¯rce zahrnujÃ­ osobu, organizaci nebo sluÅŸbu. K oznaÄenÃ­ entity se typicky pouÅŸÃ­vÃ¡ jmÃ©no tvÅ¯rce.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Auteur of maker</Attribute>
+      <Attribute name="definition">De auteur, maker of organisatie die primair verantwoordelijk is voor de intellectuele inhoud van het werk. Bijvoorbeeld auteurs in geval van geschreven documenten, artiesten, fotografen of illustrators in geval van visuele bronnen.</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
     </Language>
 
@@ -380,4 +441,24 @@
     </Language>
 
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">PÅedmÄt a klÃ­ÄovÃ¡ slova</Attribute>
+      <Attribute name="definition">TÃ©ma obsahu zdroje.</Attribute>
+      <Attribute name="comment">PÅedmÄt bude typicky vyjÃ¡dÅen pomocÃ­ klÃ­ÄovÃœch slov, klÃ­ÄovÃœch frÃ¡zÃ­ nebo klasifikaÄnÃ­ch znakÅ¯ popisujÃ­cÃ­ch tÃ©ma zdroje. DoporuÄuje se vybÃ­rat hodnotu prvku z ÅÃ­zenÃ©ho slovnÃ­ku nebo formÃ¡lnÃ­ho klasifikaÄnÃ­ho schÃ©matu.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Onderwerp en trefwoorden</Attribute>
+      <Attribute name="definition">Het onderwerp van de Internetbron. Het onderwerp wordt beschreven in korte zinnen of door het gebruik van trefwoorden. Het gebruik van gecontroleerde trefwoorden of classificatie schema's wordt aanbevolen.</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
+    </Language>
+
     <!-- Interlingua -->
     <Language code="ia">
@@ -464,4 +545,24 @@
     </Language>
 
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">Popis</Attribute>
+      <Attribute name="definition">VysvÄtlenÃ­ obsahu zdroje.</Attribute>
+      <Attribute name="comment">Popis mÅ¯ÅŸe obsahovat (mimo jinÃ©): abstrakt, obsah, odkaz na grafickÃ© nebo volnÃ© textovÃ© vyjÃ¡dÅenÃ­ obsahu.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Omschrijving</Attribute>
+      <Attribute name="definition">Een omschrijving van de inhoud van de Internetbron. Abstracts of inhoudsomschrijvingen.</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
+    </Language>
+
     <!-- Interlingua -->
     <Language code="ia">
@@ -541,4 +642,24 @@
 æ¬äžªäœïŒç»ç»ïŒææå¡ãäžè¬èèšïŒåºè¯¥çšåºçè
 çåç§°æ¥æ è¯è¿äžæ¡ç®ã</Attribute>
+    </Language>
+
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">Vydavatel</Attribute>
+      <Attribute name="definition">Entita odpovÄdnÃ¡ za zpÅÃ­stupnÄnÃ­ zdroje.</Attribute>
+      <Attribute name="comment">PÅÃ­klady Vydavatele zahrnujÃ­ osobu, organizaci nebo sluÅŸbu. K oznaÄenÃ­ entity se typicky pouÅŸÃ­vÃ¡ jmÃ©no vydavatele.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Uitgever</Attribute>
+      <Attribute name="definition">De entiteit die verantwoordelijk is voor het beschikbaarstellen van de Internetbron in de huidig vorm. Bijvoorbeeld een uitgeversbedrijf, een universiteitsafdeling.</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
     </Language>
 
@@ -643,4 +764,24 @@
     </Language>
 
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">PÅispÄvatel</Attribute>
+      <Attribute name="definition">Entita, kterÃ¡ pÅispÄla k vytvoÅenÃ­ obsahu zdroje.</Attribute>
+      <Attribute name="comment">PÅÃ­klady PÅispÄvatele zahrnujÃ­ osobu, organizaci nebo sluÅŸbu. K oznaÄenÃ­ entity se typicky pouÅŸÃ­vÃ¡ jmÃ©no pÅispÄvatele.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Andere medewerkers</Attribute>
+      <Attribute name="definition">Een persoon of organisatie die een belangrijke bijdrage heeft geleverd, maar die secondair is aan de persoon of organisatie die bij "Creator" genoemd wordt. Gedacht kan worden aan editors, vertalers en illustrators.</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
+    </Language>
+
     <!-- Interlingua -->
     <Language code="ia">
@@ -729,4 +870,24 @@
     </Language>
 
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">Datum</Attribute>
+      <Attribute name="definition">Datum spojenÃ© s urÄitou udÃ¡lostÃ­ bÄhem existence zdroje.</Attribute>
+      <Attribute name="comment">Datum bude typicky spojeno s vytvoÅenÃ­m nebo zpÅÃ­stupnÄnÃ­m zdroje. DoporuÄenÃœ postup pro kÃ³dovÃ¡nÃ­ hodnoty data je definovÃ¡n v ISO 8601 [W3CDTF]: formÃ¡t RRRR-MM-DD.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Datum</Attribute>
+      <Attribute name="definition">De datum van de totstandkoming of beschikbaarstelling van een Internetbron. Deze datum moet niet verward worden met de datum in "Coverage". De datum in "Coverage" geeft de tijdsperiode van de inhoud van de Internetbron aan. Voorgeschreven wordt de ISO 8601 standaard voor datum, zoals beschreven in W3C Technical Note http://www.w3.org/TR/NOTE-datetime. Hierin wordt het formaat YYYY-MM-DD beschreven. Het formaat YYYY-MM-DD wordt de voorgeschreven standaard. 3 September 1998 wordt in dit geval 1998-09-03.</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
+    </Language>
+
     <!-- Interlingua -->
     <Language code="ia">
@@ -815,4 +976,24 @@
 å®¹çäžè¬èçŽïŒåèœïŒç§å±ïŒæèç±»å±æ¬¡çæ¯è¯­ãå»ºè®®éçšæ¥èªäºåæ§è¯è¡š    äž­çåŒïŒäŸåŠDCMIç±»åè¯æ±è¡š[DCMITYPE]ïŒãèŠæè¿°èµæºçç©çææ°å­åè¡šç°åœ¢åŒïŒè¯·äœ¿çšâæ ŒåŒïŒFORMATïŒâå
 çŽ ã</Attribute>
+    </Language>
+
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">Typ zdroje</Attribute>
+      <Attribute name="definition">Povaha nebo druh obsahu zdroje.</Attribute>
+      <Attribute name="comment">Typ obsahuje termÃ­ny popisujÃ­cÃ­ obecnÃ© kategorie, funkce, druhy nebo agregaÄnÃ­ ÃºrovnÄ obsahu. DoporuÄuje se vybÃ­rat hodnotu z ÅÃ­zenÃ©ho slovnÃ­ku (napÅ. pracovnÃ­ nÃ¡vrh seznamu TypÅ¯ Dublin Core [DCT1]). K popisu fyzickÃ© nebo digitÃ¡lnÃ­ reprezentace zdroje uÅŸijte prvek FormÃ¡t.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Bestands type</Attribute>
+      <Attribute name="definition">Het soort Internetbron, bijvoorbeeld home page, gedicht, working paper, technical report, essay, woordenboek etc. De DC working groups zijn momenteel bezig met twee voorstellen; een minimalist draft: http://sunsite.berkeley.edu/Metadata/minimalist.html en een structuralist draft: http://sunsite.berkely.edu/Metadata/structuralist.html. Het wordt sterk aanbevolen om "Type" van deze lijsten te selecteren.</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
     </Language>
 
@@ -906,4 +1087,24 @@
     </Language>
 
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">FormÃ¡t</Attribute>
+      <Attribute name="definition">FyzickÃ¡ nebo digitÃ¡lnÃ­ reprezentace zdroje.</Attribute>
+      <Attribute name="comment">Typicky mÅ¯ÅŸe FormÃ¡t obsahovat typ mÃ©dia nebo rozmÄry zdroje. FormÃ¡t lze pouÅŸÃ­vat k urÄenÃ­ softwaru, hardwaru nebo dalÅ¡Ã­ho zaÅÃ­zenÃ­ potÅebnÃ©ho k zobrazenÃ­ nebo k manipulaci se zdrojem. PÅÃ­klady rozmÄrÅ¯ zahrnujÃ­ velikost a dobu trvÃ¡nÃ­. DoporuÄuje se vybÃ­rat hodnotu z ÅÃ­zenÃ©ho slovnÃ­ku (napÅ. seznam typÅ¯ internetovÃœch mÃ©diÃ­ [MIME] definujÃ­cÃ­ formÃ¡ty poÄÃ­taÄovÃœch mÃ©diÃ­).</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Format</Attribute>
+      <Attribute name="definition">Het data formaat van het Internetbestand. Dit gegeven kan gebruikt worden om systeemvereisten (hard- en software) te identificeren die nodig zijn voor raadpleging of bediening van de Internetbron. "Format" is nog in ontwikkeling bij de DC workshop. Uit compatibiliteitsoverwegingen wordt aanbevolen formaatgegevens te selecteren uit een gecontroleerde lijst. Formaten kunnen van de Internet Media Types (MIME types) lijst gekozen worden: http://www.isi.edu/in-notes/iana/assignments/media-types/media-types</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
+    </Language>
+
     <!-- Interlingua -->
     <Language code="ia">
@@ -994,4 +1195,25 @@
 æ¬åäžèµæºå®äœç¬ŠURL)ãæ°å­å¯¹è±¡æ è¯ç¬Š(DOI)ååœé
 æ åä¹Šå·(ISBN)ã</Attribute>
+    </Language>
+
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">IdentifikÃ¡tor zdroje</Attribute>
+      <Attribute name="definition">JednoznaÄnÃœ odkaz na zdroj v rÃ¡mci danÃ©ho kontextu.</Attribute>
+      <Attribute name="comment">DoporuÄuje se
+identifikovat zdroj znakovÃœm ÅetÄzcem nebo ÄÃ­slem odpovÃ­dajÃ­cÃ­m nÄkterÃ©mu z formÃ¡lnÃ­ch identifikaÄnÃ­ch systÃ©mÅ¯. PÅÃ­klady formÃ¡lnÃ­ch identifikaÄnÃ­ch systÃ©mÅ¯ zahrnujÃ­ Uniform Resource Identifier (URI) (vÄetnÄ Uniform Resource Locator (URL)), Digital Object Identifier (DOI) a MezinÃ¡rodnÃ­ standardnÃ­ ÄÃ­slo knihy (ISBN).</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Bestandsidentificatie</Attribute>
+      <Attribute name="definition">Een unieke string of nummer ter identificatie van de Internetbron. Voorbeelden zijn URL's of URN's Andere voorbeelden zijn International Standard Book Number (ISBN) of International Standard Serial Number (ISSN)</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
     </Language>
 
@@ -1096,4 +1318,24 @@
     </Language>
 
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">Zdroj</Attribute>
+      <Attribute name="definition">Odkaz na zdroj, z nÄhoÅŸ je popisovanÃœ zdroj odvozen.</Attribute>
+      <Attribute name="comment">PopisovanÃœ zdroj mÅ¯ÅŸe bÃœt zcela nebo zÄÃ¡sti odvozen ze zdroje uvedenÃ©ho v prvku Zdroj. DoporuÄuje se odkazovat zdroj znakovÃœm ÅetÄzcem nebo ÄÃ­slem odpovÃ­dajÃ­cÃ­m nÄkterÃ©mu z formÃ¡lnÃ­ch identifikaÄnÃ­ch systÃ©mÅ¯.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Bron</Attribute>
+      <Attribute name="definition">Informatie over een tweede bron waar de huidige Internetbron is van afgeleid. Bij "Source" mag een datum, auteur of maker, formaat, identificatie of andere metadata voor de tweede bron worden ingevuld. Voorbeeld: het is mogelijk om een "Source" datum 1603 in een omschrijving van een 1996 film bewerking van een Shakespeare stuk te gebruiken. "Source" is niet bruikbaar wanneer de huidige bron de orginele is.</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
+    </Language>
+
     <!-- Interlingua -->
     <Language code="ia">
@@ -1176,4 +1418,24 @@
 çŽ çåŒéçšRFC 3066[RFC3066]ïŒè¯¥æ åäžISO 639 [ISO639]äžèµ·å®ä¹äºç±äž€äžªåäžäžªè±    æå­æ¯ç»æçäž»è¯­èšæ ç­Ÿåå­æ ç­ŸäŸåŠå
 æ¬âenâæâengâæ¥è¡šç€ºEnglish, "akk" æ¥è¡šç€º    "en-GB"è¡šç€ºè±åœè±è¯­ã</Attribute>
+    </Language>
+
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">Jazyk</Attribute>
+      <Attribute name="definition">Jazyk intelektuÃ¡lnÃ­ho obsahu zdroje.</Attribute>
+      <Attribute name="comment">DoporuÄenÃœ postup pro hodnoty prvku Jazyk je definovÃ¡n v RFC 1766 [RFC1766]: dvouznakovÃœ kÃ³d jazyka (pÅevzatÃœ z normy ISO 639 [ISO639]) volitelnÄ nÃ¡sledovanÃœ dvouznakovÃœm kÃ³dem zemÄ (pÅevzatÃœm z normy ISO 3166 [ISO3166]). NapÅÃ­klad 'en' pro angliÄtinu, 'fr' pro francouzÅ¡tinu, 'cs' pro ÄeÅ¡tinu, nebo 'en-uk' pro angliÄtinu uÅŸÃ­vanou ve SpojenÃ©m krÃ¡lovstvÃ­.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Taal</Attribute>
+      <Attribute name="definition">De taal waarin het document is beschreven. Voorgeschreven wordt de ISO639-1 norm, een twee karakter taalcode van de ISO 639(639-1 en 639-2) norm. Taalcodes kunnen van een lijst worden gekozen: http://www.ics.uci.edu/pub/ietf/http/related/iso639.txt, Eventueel kan ISO3166 (landencodes) gebruikt worden om aan te geven in welk gebied de taal wordt gesproken. Deze kunnen ook van een lijst worden gekozen:  http://www.ics.uci.edu/pub/ietf/http/related/iso3166.txt.</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
     </Language>
 
@@ -1279,4 +1541,24 @@
 ³èµæºæ¶ïŒå»ºè®®äœ¿çšç¬Šåæ­£åŒæ è¯ç³»ç»çå­ç¬Šäž²æè
 æ°å­ã</Attribute>
+    </Language>
+
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">Vztah</Attribute>
+      <Attribute name="definition">Odkaz na pÅÃ­buznÃœ zdroj.</Attribute>
+      <Attribute name="comment">DoporuÄuje se odkazovat zdroj znakovÃœm ÅetÄzcem nebo ÄÃ­slem odpovÃ­dajÃ­cÃ­m nÄkterÃ©mu z formÃ¡lnÃ­ch identifikaÄnÃ­ch systÃ©mÅ¯.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Relatie</Attribute>
+      <Attribute name="definition">Een identificatie van een tweede bron en de relatie met de huide Internetbron. Voorbeelden zijn een editie van een werk (IsVersionOf), een vertaling van een werk (IsBasedOn), een hoofdstuk van een boek (IsPartOf) en een mechanische transformatie van een dataset in een plaatje (IsFormatOf). De DC Working Groups zijn bezig met een lijst met de meest verwachte relaties. Aanbevolen wordt om de relaties van deze lijst te gebruiken: http://purl.oclc.org/metadata/dublin_core/wrelationdraft.html.</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
     </Language>
 
@@ -1393,4 +1675,24 @@
     </Language>
 
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">PokrytÃ­</Attribute>
+      <Attribute name="definition">Rozsah nebo zÃ¡bÄr obsahu zdroje.</Attribute>
+      <Attribute name="comment">PokrytÃ­ bude typicky obsahovat prostorovÃ© umÃ­stÄnÃ­ (jmÃ©no mÃ­sta nebo zemÄpisnÃ© souÅadnice), ÄasovÃ© obdobÃ­ (oznaÄenÃ­ obdobÃ­, datum nebo ÄasovÃœ interval) nebo jurisdikci (napÅ. jmÃ©no administrativnÃ­ jednotky). DoporuÄuje se vybÃ­rat hodnotu z ÅÃ­zenÃ©ho slovnÃ­ku (napÅ. Thesaurus of Geographic Names [TGN]) a tam, kde je to vhodnÃ©, uvÃ¡dÄt mÃ­sta nebo ÄasovÃ© Ãºseky spÃ­Å¡e jmÃ©nem neÅŸ ÄÃ­selnÃœmi identifikÃ¡tory jako jsou soubory souÅadnic nebo ÄasovÃ© intervaly.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Dekking</Attribute>
+      <Attribute name="definition">De ruimtelijke of tijdelijke karakteristieken van de intellectuele inhoud van de Internetbron. Ruimtelijke dekking verwijst naar een geografisch gebied. Gebruik coordinaten (longitude (lengtegraad) en latitude (breedtegraad)) of plaatsnamen die van een gecontroleerde lijst komen of volledig uitgeschreven zijn. Dekking in de tijd geeft de tijdsperiode aan waarop de inhoud van de Internetbron betrekking heeft en niet wanneer de Internetbron is gemaakt of beschikbaar is gesteld (dit laatste hoort ingevult te worden bij "Date"). Gebruik dezelfde datum/tijd formaat als bij "Date"; W3C Technical Note http://www.w3.org/TR/NOTE-datetime of tijdsperioden die van een gecontroleerde lijst komen of volledig uitgeschreven zijn. Coverage is in ontwikkeling bij de Dublin Core Working group http://www.alexandria.ucsb.edu/docs/metadata/dc_coverage.html.</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
+    </Language>
+
     <!-- Interlingua -->
     <Language code="ia">
@@ -1491,4 +1793,24 @@
     </Language>
 
+    <!-- Czech -->
+    <Language code="cs">
+      <Attribute name="identifier">PrÃ¡va</Attribute>
+      <Attribute name="definition">Informace o prÃ¡vech vztahujÃ­cÃ­ch se k popisovanÃ©mu zdroji.</Attribute>
+      <Attribute name="comment">Prvek PrÃ¡va bude typicky obsahovat ustanovenÃ­ o sprÃ¡vÄ autorskÃœch/vlastnickÃœch prÃ¡v ke zdroji nebo odkaz na sluÅŸbu poskytujÃ­cÃ­ takovÃ©to informace. Informace o prÃ¡vech Äasto zahrnujÃ­ prÃ¡va duÅ¡evnÃ­ho vlastnictvÃ­ (IPR), autorskÃ© prÃ¡vo a rÅ¯znÃ¡ vlastnickÃ¡ prÃ¡va. JestliÅŸe prvek PrÃ¡va chybÃ­, nelze odvozovat ÅŸÃ¡dnÃ© pÅedpoklady o stavu tÄchto a jinÃœch prÃ¡v vztahujÃ­cÃ­ch se k popisovanÃ©mu zdroji.</Attribute>
+    </Language>
+
+    <!-- Dutch -->
+    <Language code="nl">
+      <Attribute name="identifier">Copyright</Attribute>
+      <Attribute name="definition">Een copyright verklaring of een link naar een copyright verklaring of een link naar een service die informatie geeft over de copyright van de Internetbron.</Attribute>
+    </Language>
+
+    <!-- Finnish -->
+    <Language code="fi">
+      <Attribute name="identifier"></Attribute>
+      <Attribute name="definition"></Attribute>
+      <Attribute name="comment"></Attribute>
+    </Language>
+
     <!-- Interlingua -->
     <Language code="ia">