Index: /trunk/gli/src/org/greenstone/gatherer/util/StatusHTML.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/util/StatusHTML.java	(revision 6662)
+++ /trunk/gli/src/org/greenstone/gatherer/util/StatusHTML.java	(revision 6663)
@@ -5,4 +5,6 @@
 
 public class StatusHTML {
+
+    static final private String GLI_VERSION = "GLI v2.50";
 
     static final private String DARK_GREEN  = "B0D0B0";
@@ -17,12 +19,12 @@
     static final private String NOTHING_STR   = "Nothing";
 
-    static final private String FEATURES = "  <!-- Header -->\n  <TR bgcolor=\"#B0B0D0\">\n    <TD colspan=\"2\"><STRONG><A name=\"23b\">GLI v2.41 - Feature Requests [FEATURE_COUNT total]</A></STRONG></TD>\n  </TR>\n  <TR>\n    <TD bgcolor=\"#FFFFFF\" colspan=\"2\">In order received. Similar problems only mentioned once, with descriptions combined where possible.</TD>\n  </TR>\n  <TR>\n    <TD colspan=\"2\">&#160;</TD>\n  </TR>\n";
+    static final private String FEATURES = "  <!-- Header -->\n  <TR bgcolor=\"#B0B0D0\">\n    <TD colspan=\"2\"><STRONG><A name=\"23b\">"+GLI_VERSION+" - Feature Requests [FEATURE_COUNT total]</A></STRONG></TD>\n  </TR>\n  <TR>\n    <TD bgcolor=\"#FFFFFF\" colspan=\"2\">In order received. Similar problems only mentioned once, with descriptions combined where possible.</TD>\n  </TR>\n  <TR>\n    <TD colspan=\"2\">&#160;</TD>\n  </TR>\n";
 
-    static final private String FIXED = "  <!-- Header -->\n  <TR bgcolor=\"#B0D0B0\">\n    <TD colspan=\"2\"><STRONG><A name=\"23b\">GLI v2.41 - Closed Reports [FIXED_COUNT total]</A></STRONG></TD>\n  </TR>\n  <TR>\n    <TD bgcolor=\"#FFFFFF\" colspan=\"2\">In order received. Similar problems only mentioned once, with descriptions combined where possible.</TD>\n  </TR>\n  <TR>\n    <TD colspan=\"2\">&#160;</TD>\n  </TR>\n";
+    static final private String FIXED = "  <!-- Header -->\n  <TR bgcolor=\"#B0D0B0\">\n    <TD colspan=\"2\"><STRONG><A name=\"23b\">"+GLI_VERSION+" - Closed Reports [FIXED_COUNT total]</A></STRONG></TD>\n  </TR>\n  <TR>\n    <TD bgcolor=\"#FFFFFF\" colspan=\"2\">In order received. Similar problems only mentioned once, with descriptions combined where possible.</TD>\n  </TR>\n  <TR>\n    <TD colspan=\"2\">&#160;</TD>\n  </TR>\n";
 
     static final private String FOOTER = "  <TR><TD>&nbsp;</TD></TR>\n</TABLE>\n<TABLE bgcolor=\"#FFFFFF\" width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n  <TR>\n    <TD align=\"center\">Written by John Thompson. Any comments, bug reports email <A href=\"mailto:jmt12@cs.waikato.ac.nz\">here</A>.</TD>\n  </TR>\n</TABLE>\n</BODY>\n</HTML>";
-    static final private String HEADER = "<HTML>\n<HEAD>\n<TITLE>GLI Project Status</TITLE>\n</HEAD>\n<BODY bgcolor=\"#CCCCCC\">\n<TABLE bgcolor=\"#FFFFFF\" width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n  <!-- Header -->\n  <TR bgcolor=\"#B0D0B0\">\n    <TD align=\"center\" colspan=\"7\"><FONT size=\"4\"><STRONG>Greenstone Librarian Interface (GLI) version 2.41</STRONG></FONT></TD>\n  </TR>\n  <TR>\n    <TD colspan=\"7\">This page lists the features planned for the Greenstone Librarian Interface in its next release. It also details the various bugs that have been found and reported in this version of the GLI.</TD>\n  </TR>\n</TABLE>\n<BR/>\n<TABLE border=\"0\" cellpadding=\"5\" cellspacing=\"0\" width=\"100%\">\n";
+    static final private String HEADER = "<HTML>\n<HEAD>\n<TITLE>GLI Project Status</TITLE>\n</HEAD>\n<BODY bgcolor=\"#CCCCCC\">\n<TABLE bgcolor=\"#FFFFFF\" width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n  <!-- Header -->\n  <TR bgcolor=\"#B0D0B0\">\n    <TD align=\"center\" colspan=\"7\"><FONT size=\"4\"><STRONG>Greenstone Librarian Interface ("+GLI_VERSION+")</STRONG></FONT></TD>\n  </TR>\n  <TR>\n    <TD colspan=\"7\">This page lists the features planned for the Greenstone Librarian Interface in its next release. It also details the various bugs that have been found and reported in this version of the GLI.</TD>\n  </TR>\n</TABLE>\n<BR/>\n<TABLE border=\"0\" cellpadding=\"5\" cellspacing=\"0\" width=\"100%\">\n";
     
-    static final private String PENDING = "  <TR><TD bgcolor=\"#CCCCCC\">&nbsp;</TD></TR>\n  <!-- Header -->\n  <TR bgcolor=\"#D0B0B0\">\n    <TD colspan=\"2\"><STRONG><A name=\"23b\">GLI v2.41 - Current Reports [PENDING_COUNT total]</A></STRONG></TD>\n  </TR>\n  <TR>\n    <TD bgcolor=\"#FFFFFF\" colspan=\"2\">In order received. Similar problems only mentioned once, with descriptions combined where possible.</TD>\n  </TR>\n  <TR>\n    <TD colspan=\"2\">&#160;</TD>\n  </TR>\n";
+    static final private String PENDING = "  <TR><TD bgcolor=\"#CCCCCC\">&nbsp;</TD></TR>\n  <!-- Header -->\n  <TR bgcolor=\"#D0B0B0\">\n    <TD colspan=\"2\"><STRONG><A name=\"23b\">"+GLI_VERSION+" - Current Reports [PENDING_COUNT total]</A></STRONG></TD>\n  </TR>\n  <TR>\n    <TD bgcolor=\"#FFFFFF\" colspan=\"2\">In order received. Similar problems only mentioned once, with descriptions combined where possible.</TD>\n  </TR>\n  <TR>\n    <TD colspan=\"2\">&#160;</TD>\n  </TR>\n";
 
     static final private String[] PREFIX = { 	"  <TR><TD bgcolor=\"#DARK_COLOR\" valign=\"top\">ID#</TD>              <TD bgcolor=\"#DARK_COLOR\">","  <TR><TD bgcolor=\"#DARK_COLOR\" valign=\"top\">Description</TD>      <TD bgcolor=\"#LIGHT_COLOR\">","  <TR><TD bgcolor=\"#DARK_COLOR\" valign=\"top\">Reported By</TD>      <TD bgcolor=\"#FFFFFF\">","  <TR><TD bgcolor=\"#DARK_COLOR\" valign=\"top\">Platform</TD>         <TD bgcolor=\"#FFFFFF\">","  <TR><TD bgcolor=\"#DARK_COLOR\" valign=\"top\">Test Item#</TD>       <TD bgcolor=\"#FFFFFF\">","  <TR><TD bgcolor=\"#DARK_COLOR\" valign=\"top\">Status</TD>           <TD bgcolor=\"#FFFFFF\">","  <TR><TD bgcolor=\"#DARK_COLOR\" valign=\"top\">Proposed Solution</TD><TD bgcolor=\"#FFFFFF\">","  <TR><TD bgcolor=\"#DARK_COLOR\" valign=\"top\">Solution</TD><TD bgcolor=\"#FFFFFF\">",  "  <TR><TD bgcolor=\"#CCCCCC\">&nbsp;"};